﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region
Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private fx As JFX
	Private tp1 As TabPane
	Private pntab As Pane
	Private sp1 As ScrollPane
	Private pnribbon As Pane
	Public tpg1 As TabPage
	Public tpg2 As TabPage
	Public tpg3 As TabPage
	Private lbltest As Label
	Private pnsaveclicked As Boolean = False
	Private tooltipstyle As String
	' ribbon views
	Private btnbold As Button
	Private btnitalic As Button
	Private cbxfont As B4XComboBox
	Private btnnew As Button
	Private btnopen As Button
	Private btnsave As Button
	Private btncopy As Button
	Private btncut As Button
	Private btnpaste As Button
	Private btnunderline As Button
	Private lblcut As Label
	Private clvfonts As CustomListView
	Private lblfontitem As Label
	Private ivsave As ImageView
	Private pnsave As Pane
	Private ivcut As ImageView
	Private lblcopy As Label
	Private lblpaste As Label
	Private ivcopy As ImageView
	Private ivpaste As ImageView
End Sub
Public Sub Initialize
	B4XPages.GetManager.LogEvents = True
End Sub
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me,"Ribbon test")
	tpg1 = add_tabpage("Start","tpstart")
	add_tpg1_groups
	tpg2 = add_tabpage("Edit","tpedit")
	add_tpg2_groups
	tpg3 = add_tabpage("Design","tpdesign")
	add_tpg3_groups
	tooltipstyle = File.ReadString(File.DirAssets,"tooltipstyle.css")
End Sub
Private Sub B4XPage_Appear

End Sub
Private Sub B4XPage_Resize (Width As Int, Height As Int)
	For Each tpg As TabPage In tp1.Tabs
		Dim pnc As Pane = tpg.Content
		Dim sp As B4XView = pnc.GetNode(0)
		sp.Width = tp1.PrefWidth
	Next
End Sub
Private Sub add_tabpage(tabname As String, tag As String) As TabPage
	Dim tpg As TabPage = tp1.LoadLayout("pntab_layout",tabname)
	pntab.LoadLayout("pnribbon_layout")
	tpg.Content = pntab
	tpg.Tag = tag
	Return tpg
End Sub
Private Sub add_tpg1_groups
	add_group_pane(tpg1,tpg1.Tag & "_grp1",0,0,200,150)
	add_group_pane(tpg1,tpg1.Tag & "_grp2",200,0,200,150)
	fill_cbxfont
	' to test the scrolling
	add_group_pane(tpg1,tpg1.Tag & "_grp1",400,0,200,150)
	add_group_pane(tpg1,tpg1.Tag & "_grp2",600,0,200,150)
	fill_cbxfont
End Sub
Private Sub add_tpg2_groups
	add_group_pane(tpg2,tpg2.Tag & "_grp1",0,0,200,150)
End Sub
Private Sub add_tpg3_groups
	add_group_pane(tpg3,tpg3.Tag & "_grp1",0,0,200,150)
	fill_clvfonts
End Sub
Private Sub add_group_pane(tpg As TabPage, tag As String, left As Int, top As  Int, width As Int, height As Int)
	Dim pngr As Pane
	pngr.Initialize(tag)
	pngr.LoadLayout(tag & "_layout")
	pngr.Tag = tag
	Dim pnc As Pane = tpg.Content
	Dim pnr As Pane = pnc.GetNode(0)
	Dim sp As ScrollPane = pnc.GetNode(1)
	pnr.AddNode(pngr,left,top,width,height)
	sp.InnerNode = pnr		
End Sub
Private Sub tp1_TabChanged (SelectedTab As TabPage)
	sp1.PrefWidth = tp1.PrefWidth
End Sub
Private Sub change_lbltest_font(fntname As String)
	Dim fnt As Font = fx.CreateFont(fntname,20,False,False)
	lbltest.Font = fnt
	lbltest.Text = "This is a text in font " & fnt.FamilyName
End Sub
#Region tpstart_grp1
Private Sub btnnew_Click
	
End Sub
Private Sub btnopen_Click
	
End Sub
Private Sub btnsave_Click
	
End Sub
Private Sub pnsave_MouseClicked (EventData As MouseEvent)
	pnsaveclicked = True
	xui.MsgboxAsync("Save clicked","Panel Save")
End Sub
Private Sub pnsave_MouseReleased (EventData As MouseEvent)
	Dim pn As Pane = Sender
	pn.As(B4XView).SetColorAnimated(0,xui.Color_ARGB(255,230,230,250),xui.Color_White)
	pnsaveclicked = False
End Sub
Private Sub pnsave_MouseEntered (EventData As MouseEvent)
	Dim pn As Pane = Sender
	pn.As(B4XView).SetColorAnimated(0,xui.Color_White,xui.Color_ARGB(255,230,230,250))
End Sub
Private Sub pnsave_MouseExited (EventData As MouseEvent)
	If pnsaveclicked = True Then
		pnsaveclicked = False
	Else
		Dim pn As Pane = Sender
		pn.As(B4XView).SetColorAnimated(0,xui.Color_ARGB(255,230,230,250),xui.Color_White)
		pnsaveclicked = False
	End If
End Sub
#End Region
#Region tpstart_grp2
Private Sub fill_cbxfont
	Dim lst As List = fx.GetAllFontFamilies
	cbxfont.SetItems(lst)
End Sub
Private Sub cbxfont_SelectedIndexChanged (Index As Int)
	change_lbltest_font(cbxfont.GetItem(Index))
End Sub
Private Sub btnbold_Click
	lbltest.Font = fx.CreateFont(cbxfont.GetItem(cbxfont.SelectedIndex),20,True,False)
End Sub
Private Sub btnitalic_Click
	lbltest.Font = fx.CreateFont(cbxfont.GetItem(cbxfont.SelectedIndex),20,False,True)
End Sub
Private Sub btnunderline_Click
	
End Sub
#End Region
#Region tpedit_grp1
Private Sub set_tooltip_style(vw As B4XView)
	Dim jo As JavaObject = vw
	Dim tooltip As JavaObject = jo.RunMethodJO("getTooltip",Null)
	tooltip.RunMethod("setStyle",Array As Object(tooltipstyle))
End Sub
Private Sub set_hover_label_style(iv As B4XView, lbl As B4XView)
	iv.BringToFront
	set_tooltip_style(lbl)
	lbl.SetColorAnimated(0,xui.Color_White,xui.Color_ARGB(255,230,230,250))	
End Sub
Private Sub lblcut_MouseClicked (EventData As MouseEvent)
	xui.MsgboxAsync("label Cut clicked","Label Cut")
End Sub
Private Sub lblcut_MouseEntered (EventData As MouseEvent)
	set_hover_label_style(ivcut,lblcut)
End Sub
Private Sub lblcut_MouseExited (EventData As MouseEvent)
	lblcut.As(B4XView).SetColorAnimated(0,xui.Color_ARGB(255,230,230,250),xui.Color_White)
End Sub
Private Sub lblcopy_MouseClicked (EventData As MouseEvent)
	xui.MsgboxAsync("label Copy clicked","Label Copy")
End Sub
Private Sub lblcopy_MouseEntered (EventData As MouseEvent)
	set_hover_label_style(ivcopy,lblcopy)
End Sub
Private Sub lblcopy_MouseExited (EventData As MouseEvent)
	lblcopy.As(B4XView).SetColorAnimated(0,xui.Color_ARGB(255,230,230,250),xui.Color_White)
End Sub
Private Sub lblpaste_MouseClicked (EventData As MouseEvent)
	xui.MsgboxAsync("label Paste clicked","Label Paste")	
End Sub
Private Sub lblpaste_MouseEntered (EventData As MouseEvent)
	set_hover_label_style(ivpaste,lblpaste)
End Sub
Private Sub lblpaste_MouseExited (EventData As MouseEvent)
	lblpaste.As(B4XView).SetColorAnimated(0,xui.Color_ARGB(255,230,230,250),xui.Color_White)
End Sub
#End Region
#Region tpdesign_grp1
Private Sub fill_clvfonts
	Dim lst As List = fx.GetAllFontFamilies
	For i = 0 To lst.Size -1
		Dim pn As Pane = set_clvfonts_item(lst.Get(i))
		clvfonts.Add(pn,pn.tag)
	Next
End Sub
Private Sub set_clvfonts_item(fntname As String) As Pane
	Dim pn As Pane = xui.CreatePanel("")
	pn.LoadLayout("clvfontsitem_layout")
	pn.SetLayoutAnimated(0,0,0,280,25)
	lblfontitem.Font = fx.CreateFont(fntname,14,False,False)
	lblfontitem.Text = fntname
	pn.Tag = fntname
	Return pn
End Sub
Private Sub clvfonts_ItemClick (Index As Int, Value As Object)
	change_lbltest_font(clvfonts.GetValue(Index))
End Sub
#End Region


